<!DOCTYPE html>
<html lang="en">
<head>
<meta name="viewport" content="width=device-width">
<meta charset=UTF-8 />
<title>HFS %version%</title>
<style>
a, li span:last-child, small {cursor: pointer; text-decoration: none}
li a[onclick]::before {content:"\1f4c1"}
li>div, aside, header {display: flex; flex-wrap: wrap; justify-content: space-between; font-family:Helvetica; width:100%}
li {display:flex; padding: .3em 0; border-top: 1px solid #ddd}
li span {color:#777}
a[href*="."]::before {content:"\1f5ce  "}
a[href$=".mp3"]::before {content:"\266a  "}
a[href$=".jpg"]::before {content:"\1f304"}
img+div a[href$=".jpg"]::before {content:""}
.checked {background:#f5f5f5}
.check div span:last-child::after {content:" \2610"}
.check .checked span:last-child::after {content:" \2611"}
header {background:#555}
aside {padding: 1.33em 0}
nav {font-weight: bold; background:#cde}
small::after {content:" files\1f552"}
a[onclick]:active {background:#c2c2c2}
/*body {background:#555; color:white}*/ /*dark theme*/
@media (min-width:360px) {header button::after {content:" "attr(id)} #Login>span:empty::after {content:" Login"}}
#Login::after {content:""}
nav a:first-child::before {content:"\2302"} 
.loading {background:#cde}
nav a {color:#000}
</style>
</head>

<body>
<header><button id='upload' onclick="fileElem.click()">&#x21e7;</button><input type="file" id="fileElem" multiple hidden onchange="sendFiles(this.files)">
<button id='Delete' onclick="del()">X</button>
<button id='Search' onclick="this.nextElementSibling.showModal()" title="HFS %version%">&#x2315;</button>
<dialog><input type='search' placeholder='search...' name='search'><input type='checkbox' checked title='subf'><button onclick='this.parentNode.close()'><sup>&times;</sup></button></dialog>
<button id='Login' onclick="if(this.firstElementChild.textContent) {document.execCommand('ClearAuthenticationCache');location.reload()} else location='/~login'">&#x1f464; <span>%user%</span></button>
</header>
<aside><nav></nav><small onclick="get(folder,'&sort=t')"></small></aside>
<main id='files'></main>

<script>
var folder=location.pathname.match(/.*\//)[0]

function get(val,para){ folder=val; para=para||'';
function urlvar(key) {return (location.search.slice(1).match(key+'=(.*)(&|$)')||'')[1]}
fetch(folder+'~files.lst?sort='+(urlvar('sort')||'n')+para, {credentials: "same-origin"}).then(function(response)  //query ?sort
 {response.text().then(function(txt){render(m3utojson(txt)); upload.disabled=txt.slice(-1)=='#'})} )
}

if(self.fetch) get(folder); else location='~files.lst'

function m3utojson(a) {
a=a.split(/\r?\n/); var b=[]
for (var i=1; i<a.length; i+=2) { b.push({url:a[i], modified:a[i-1].split(',')[0].slice(1,-3), size:a[i-1].split(/,0?/)[1]}) }
return b
}
</script><script>  //IE11
function render(a){
var myTemplate=a.map((item) =>
 `<li><div><a ${item.url.slice(-1)=='/'?`onclick=get('${folder+item.url}') href="javascript:void(0)"`:`href="${(item.url.match('://')?'':folder)+item.url}" target="l"`}>${decodeURI(item.url)}</a>\
<span> ${item.size}</span><span> ${item.modified}</span></div></li>`
 )
document.querySelector('main').innerHTML=myTemplate.join('\n')
document.querySelector('nav').innerHTML=bcrumbs(folder); document.querySelector('small').innerHTML=a.length
if(typeof addon=='function') addon()  //
}

function bcrumbs(f) {
var path=f.split('/'), pt='', pr=''
for(pta=0;pta<path.length-1;pta++) {pt+=path[pta]+'/'; pr+='<a href="javascript:void(onclick=get(\''+pt+'\'))">'+(path[pta]||'Home')+'</a>/'}
return pr
}

</script>
<script>
function sendFiles(filesArray) {
var fd = new FormData()
Array.from(filesArray).forEach(item => fd.append('myFile', item, item.name))
upload.classList.add("loading")
fetch(folder,{method:'POST',body:fd}).then(response => {get(folder); upload.classList.remove("loading")})
}
var dia=document.querySelector('dialog')  //mypoly
if(!dia.showModal) {dia.showModal=function(){this.hidden=false};  dia.close=function(){this.hidden=true};  dia.setAttribute('open',''); dia.hidden=true }
document.querySelector('input[type=search]').onchange = function(){get(folder,1*this.nextElementSibling.checked? "&search="+this.value:"&files-filter=*"+this.value+"*"); this.parentNode.close()}

document.querySelector('main').onclick=function(e){if(e.target.tagName=='SPAN'&&!e.target.nextSibling) e.target.parentNode.classList.toggle("checked")}

function del() {
var ref = document.querySelectorAll('.checked'), qstr=''
ref.forEach(item => qstr+='&selection='+item.firstChild.getAttribute('href'))
if(!qstr) {document.querySelector('main').classList.toggle("check"); return}
if(!confirm("Delete "+ref.length+" file(s) ?")) return
fetch(folder,{method:'POST',body:"action=delete"+qstr,headers:{"Content-type":"application/x-www-form-urlencoded"}}).then(response => get(folder))
}
</script>
</body>
</html>

[not found]
<h1>Not found</h1><a href="/">&#x2302; Home</a>

[unauthorized]
<h1>Unauthorized</h1>
&#x26d4; wrong username or password

[special:import]
{.dialog|Add hfs.filelist.tpl from zip to folder, that contains hfs.exe.}